import { Event } from "@codingame/monaco-vscode-api/vscode/vs/base/common/event";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { URI } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { IFileOpenOptions, IFileChange, IFileSystemProvider, IStat, IWatchOptions } from "@codingame/monaco-vscode-api/vscode/vs/platform/files/common/files";
import { IDebugSession } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug";
import { IDebugService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug.service";
export declare class DebugMemoryFileSystemProvider extends Disposable implements IFileSystemProvider {
    private readonly debugService;
    private memoryFdCounter;
    private readonly fdMemory;
    private readonly changeEmitter;
    readonly onDidChangeCapabilities: Event<any>;
    readonly onDidChangeFile: Event<readonly IFileChange[]>;
    readonly capabilities: number;
    constructor(debugService: IDebugService);
    watch(resource: URI, opts: IWatchOptions): import("@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle").IDisposable;
    stat(file: URI): Promise<IStat>;
    mkdir(): never;
    readdir(): never;
    delete(): never;
    rename(): never;
    open(resource: URI, _opts: IFileOpenOptions): Promise<number>;
    close(fd: number): Promise<void>;
    writeFile(resource: URI, content: Uint8Array): Promise<void>;
    readFile(resource: URI): Promise<Uint8Array<ArrayBuffer>>;
    read(fd: number, pos: number, data: Uint8Array, offset: number, length: number): Promise<number>;
    write(fd: number, pos: number, data: Uint8Array, offset: number, length: number): Promise<number>;
    protected parseUri(uri: URI): {
        session: IDebugSession;
        offset: {
            fromOffset: number;
            toOffset: number;
        } | undefined;
        readOnly: boolean;
        sessionId: string;
        memoryReference: string;
    };
}
