import { IDisposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { ICommandService } from "@codingame/monaco-vscode-api/vscode/vs/platform/commands/common/commands.service";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IDialogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/dialogs/common/dialogs.service";
import { IMarkerService } from "@codingame/monaco-vscode-api/vscode/vs/platform/markers/common/markers.service";
import { IProgressService } from "@codingame/monaco-vscode-api/vscode/vs/platform/progress/common/progress.service";
import { IStorageService } from "@codingame/monaco-vscode-api/vscode/vs/platform/storage/common/storage.service";
import { IWorkspace, IWorkspaceFolder } from "@codingame/monaco-vscode-api/vscode/vs/platform/workspace/common/workspace";
import { ITaskIdentifier } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/tasks/common/tasks";
import { ITaskSummary } from "@codingame/monaco-vscode-625898ab-0e33-5b7f-a3ae-29c10271dc1c-common/vscode/vs/workbench/contrib/tasks/common/taskService";
import { ITaskService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/tasks/common/taskService.service";
import { IViewsService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/views/common/viewsService.service";
export declare enum TaskRunResult {
    Failure = 0,
    Success = 1
}
interface IRunnerTaskSummary extends ITaskSummary {
    cancelled?: boolean;
}
export declare class DebugTaskRunner implements IDisposable {
    private readonly taskService;
    private readonly markerService;
    private readonly configurationService;
    private readonly viewsService;
    private readonly dialogService;
    private readonly storageService;
    private readonly commandService;
    private readonly progressService;
    private globalCancellation;
    constructor(taskService: ITaskService, markerService: IMarkerService, configurationService: IConfigurationService, viewsService: IViewsService, dialogService: IDialogService, storageService: IStorageService, commandService: ICommandService, progressService: IProgressService);
    cancel(): void;
    dispose(): void;
    runTaskAndCheckErrors(root: IWorkspaceFolder | IWorkspace | undefined, taskId: string | ITaskIdentifier | undefined): Promise<TaskRunResult>;
    runTask(root: IWorkspace | IWorkspaceFolder | undefined, taskId: string | ITaskIdentifier | undefined, token?: import("@codingame/monaco-vscode-api/vscode/vs/base/common/cancellation").CancellationToken): Promise<IRunnerTaskSummary | null>;
}
export {};
