import { IActionViewItem } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/ui/actionbar/actionbar";
import { DisposableStore } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { ServicesAccessor } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/editorExtensions";
import { IDropdownWithPrimaryActionViewItemOptions } from "@codingame/monaco-vscode-1bb39316-6fbf-572e-ab6a-818a2496c14f-common/vscode/vs/platform/actions/browser/dropdownWithPrimaryActionViewItem";
import { MenuItemAction } from "@codingame/monaco-vscode-api/vscode/vs/platform/actions/common/actions";
import { IMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/actions/common/actions.service";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IContextKeyService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { INotificationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/notification/common/notification.service";
import { IStorageService } from "@codingame/monaco-vscode-api/vscode/vs/platform/storage/common/storage.service";
import { ITelemetryService } from "@codingame/monaco-vscode-api/vscode/vs/platform/telemetry/common/telemetry.service";
import { Themable } from "@codingame/monaco-vscode-api/vscode/vs/platform/theme/common/themeService";
import { IThemeService } from "@codingame/monaco-vscode-api/vscode/vs/platform/theme/common/themeService.service";
import { IWorkbenchContribution } from "@codingame/monaco-vscode-api/vscode/vs/workbench/common/contributions";
import { IWorkbenchLayoutService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/layout/browser/layoutService.service";
import { IDebugService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug.service";
export declare class DebugToolBar extends Themable implements IWorkbenchContribution {
    private readonly notificationService;
    private readonly telemetryService;
    private readonly debugService;
    private readonly layoutService;
    private readonly storageService;
    private readonly configurationService;
    private readonly instantiationService;
    private $el;
    private dragArea;
    private actionBar;
    private activeActions;
    private updateScheduler;
    private debugToolBarMenu;
    private isVisible;
    private isBuilt;
    private readonly stopActionViewItemDisposables;
    private readonly auxWindowCoordinates;
    private readonly trackPixelRatioListener;
    constructor(notificationService: INotificationService, telemetryService: ITelemetryService, debugService: IDebugService, layoutService: IWorkbenchLayoutService, storageService: IStorageService, configurationService: IConfigurationService, themeService: IThemeService, instantiationService: IInstantiationService, menuService: IMenuService, contextKeyService: IContextKeyService);
    private registerListeners;
    private computeCurrentXPercent;
    private getCurrentXPercent;
    private getCurrentYPosition;
    private storePosition;
    updateStyles(): void;
    private getStoredXPosition;
    private getStoredYPosition;
    private setCoordinates;
    private get yDefault();
    private _yRange;
    private get yRange();
    private show;
    private doShowInActiveContainer;
    private hide;
    dispose(): void;
}
export declare function createDisconnectMenuItemAction(action: MenuItemAction, disposables: DisposableStore, accessor: ServicesAccessor, options: IDropdownWithPrimaryActionViewItemOptions): IActionViewItem | undefined;
