import { Dimension } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/dom";
import { BareFontInfo } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/config/fontInfo";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IContextKeyService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { IStorageService } from "@codingame/monaco-vscode-api/vscode/vs/platform/storage/common/storage.service";
import { ITelemetryService } from "@codingame/monaco-vscode-api/vscode/vs/platform/telemetry/common/telemetry.service";
import { IThemeService } from "@codingame/monaco-vscode-api/vscode/vs/platform/theme/common/themeService.service";
import { EditorPane } from "@codingame/monaco-vscode-12c5f9eb-72d3-57ca-babd-5bef7aa9de3b-common/vscode/vs/workbench/browser/parts/editor/editorPane";
import { IWorkbenchContribution } from "@codingame/monaco-vscode-api/vscode/vs/workbench/common/contributions";
import { IDebugSession } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug";
import { IDebugService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug.service";
import { IEditorService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/editor/common/editorService.service";
import { IEditorGroup } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/editor/common/editorGroupsService";
export declare class DisassemblyView extends EditorPane {
    private readonly _configurationService;
    private readonly _instantiationService;
    private readonly _debugService;
    private static readonly NUM_INSTRUCTIONS_TO_LOAD;
    private _fontInfo;
    private _disassembledInstructions;
    private _onDidChangeStackFrame;
    private _previousDebuggingState;
    private _instructionBpList;
    private _enableSourceCodeRender;
    private _loadingLock;
    private readonly _referenceToMemoryAddress;
    constructor(group: IEditorGroup, telemetryService: ITelemetryService, themeService: IThemeService, storageService: IStorageService, _configurationService: IConfigurationService, _instantiationService: IInstantiationService, _debugService: IDebugService);
    get fontInfo(): BareFontInfo;
    private createFontInfo;
    get currentInstructionAddresses(): (bigint | undefined)[];
    get focusedCurrentInstructionReference(): string | undefined;
    get focusedCurrentInstructionAddress(): bigint | undefined;
    get focusedInstructionReference(): string | undefined;
    get focusedInstructionAddress(): bigint | undefined;
    get isSourceCodeRender(): boolean;
    get debugSession(): IDebugSession | undefined;
    get onDidChangeStackFrame(): import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<void>;
    get focusedAddressAndOffset(): {
        reference: string;
        offset: number;
        address: bigint;
    } | undefined;
    protected createEditor(parent: HTMLElement): void;
    layout(dimension: Dimension): void;
    goToInstructionAndOffset(instructionReference: string, offset: number, focus?: boolean): Promise<void>;
    getReferenceAddress(instructionReference: string): bigint | undefined;
    private goToAddress;
    private scrollUp_LoadDisassembledInstructions;
    private scrollDown_LoadDisassembledInstructions;
    private primeMemoryReference;
    private loadDisassembledInstructions;
    private getIndexFromReferenceAndOffset;
    private getIndexFromAddress;
    private reloadDisassembly;
    private clear;
}
export declare class DisassemblyViewContribution implements IWorkbenchContribution {
    private readonly _onDidActiveEditorChangeListener;
    private _onDidChangeModelLanguage;
    private _languageSupportsDisassembleRequest;
    constructor(editorService: IEditorService, debugService: IDebugService, contextKeyService: IContextKeyService);
    dispose(): void;
}
