import { AccessibleViewProviderId, AccessibleViewType, IAccessibleViewContentProvider } from "@codingame/monaco-vscode-api/vscode/vs/platform/accessibility/browser/accessibleView";
import { IAccessibleViewService } from "@codingame/monaco-vscode-api/vscode/vs/platform/accessibility/browser/accessibleView.service";
import { AccessibilityVerbositySettingId } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/accessibility/browser/accessibilityConfiguration";
import { IReplElement } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug";
import { IAccessibleViewImplementation } from "@codingame/monaco-vscode-api/vscode/vs/platform/accessibility/browser/accessibleViewRegistry";
import { ServicesAccessor } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { Repl } from "./repl.js";
import { Event } from "@codingame/monaco-vscode-api/vscode/vs/base/common/event";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
export declare class ReplAccessibleView implements IAccessibleViewImplementation {
    priority: number;
    name: string;
    when: import("@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey").ContextKeyExpression;
    type: AccessibleViewType;
    getProvider(accessor: ServicesAccessor): ReplOutputAccessibleViewProvider | undefined;
}
declare class ReplOutputAccessibleViewProvider extends Disposable implements IAccessibleViewContentProvider {
    private readonly _replView;
    private readonly _focusedElement;
    private readonly _accessibleViewService;
    readonly id = AccessibleViewProviderId.Repl;
    private _content;
    private readonly _onDidChangeContent;
    readonly onDidChangeContent: Event<void>;
    private readonly _onDidResolveChildren;
    readonly onDidResolveChildren: Event<void>;
    readonly verbositySettingKey = AccessibilityVerbositySettingId.Debug;
    readonly options: {
        type: AccessibleViewType;
    };
    private _elementPositionMap;
    private _treeHadFocus;
    constructor(_replView: Repl, _focusedElement: IReplElement | undefined, _accessibleViewService: IAccessibleViewService);
    provideContent(): string;
    onClose(): void;
    onOpen(): void;
    private _updateContent;
}
export {};
