import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { ILogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/log/common/log.service";
import { IStorageService } from "@codingame/monaco-vscode-api/vscode/vs/platform/storage/common/storage.service";
import { IUriIdentityService } from "@codingame/monaco-vscode-api/vscode/vs/platform/uriIdentity/common/uriIdentity.service";
import { IDebugModel, IEvaluate, IExpression } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug";
import { Breakpoint, DataBreakpoint, ExceptionBreakpoint, Expression, FunctionBreakpoint } from "@codingame/monaco-vscode-88aa9a78-75f5-5aaa-89e9-bbdd580b3b5c-common/vscode/vs/workbench/contrib/debug/common/debugModel";
import { ITextFileService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/textfile/common/textfiles.service";
export interface IChosenEnvironment {
    type: string;
    dynamicLabel?: string;
}
export declare class DebugStorage extends Disposable {
    private readonly storageService;
    private readonly textFileService;
    private readonly uriIdentityService;
    private readonly logService;
    readonly breakpoints: import("@codingame/monaco-vscode-api/vscode/vs/base/common/observable").ISettableObservable<Breakpoint[], void>;
    readonly functionBreakpoints: import("@codingame/monaco-vscode-api/vscode/vs/base/common/observable").ISettableObservable<FunctionBreakpoint[], void>;
    readonly exceptionBreakpoints: import("@codingame/monaco-vscode-api/vscode/vs/base/common/observable").ISettableObservable<ExceptionBreakpoint[], void>;
    readonly dataBreakpoints: import("@codingame/monaco-vscode-api/vscode/vs/base/common/observable").ISettableObservable<DataBreakpoint[], void>;
    readonly watchExpressions: import("@codingame/monaco-vscode-api/vscode/vs/base/common/observable").ISettableObservable<Expression[], void>;
    constructor(storageService: IStorageService, textFileService: ITextFileService, uriIdentityService: IUriIdentityService, logService: ILogService);
    loadDebugUxState(): "simple" | "default";
    storeDebugUxState(value: "simple" | "default"): void;
    private loadBreakpoints;
    private loadFunctionBreakpoints;
    private loadExceptionBreakpoints;
    private loadDataBreakpoints;
    private loadWatchExpressions;
    loadChosenEnvironments(): Record<string, IChosenEnvironment>;
    storeChosenEnvironments(environments: Record<string, IChosenEnvironment>): void;
    storeWatchExpressions(watchExpressions: (IExpression & IEvaluate)[]): void;
    storeBreakpoints(debugModel: IDebugModel): void;
}
